## openstructure 2.2.0

=== CMakeLists.txt ===
#-------------------------------------------------------------------------------
# Author: Marco Biasini
#-------------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.12.1 FATAL_ERROR)

# Set CMake policies
# Behaviour of target_link_libraries, always link by full path. CMP0060 can
# disable this to stay compatible with old projects. We want the new behaviour
# since before we needed to provide the full path ourselves, that is: we
# manually forced CMake to the new scheme.
cmake_policy(SET CMP0060 NEW)

project(OpenStructure CXX C)
set (CMAKE_EXPORT_COMPILE_COMMANDS 1)
set (OST_VERSION_MAJOR 2)
set (OST_VERSION_MINOR 2)
set (OST_VERSION_PATCH 0)
set (OST_VERSION_STRING ${OST_VERSION_MAJOR}.${OST_VERSION_MINOR}.${OST_VERSION_PATCH} )
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake_support)
include(OST)

option(USE_SHADER "whether to compile with shader support"
       OFF)
option(USE_RPATH "embed rpath upon make install"
       OFF)
option(COMPILE_TMTOOLS "whether to compile the tmalign and tmscore programs"
       OFF)
option(PROFILE "whether to compile with profiling support"
       OFF)       
option(ENABLE_GUI "whether the graphical user interface should be enabled"
       ON)
option(ENABLE_GFX "whether graphics support should be enabled"
       ON)
option(OPENGLPREFERENCE_LEGACY "whether to use the OpenGL Legacy GL implementation"
       OFF)
option(ENABLE_IMG "whether the image processing module should be compiled"
       ON)
option(ENABLE_INFO "whether openstructure should be compiled with support for the info library"
       ON)
option(USE_NUMPY "whether numpy support is added"
      OFF)
option(USE_DOUBLE_PRECISION "whether to compile in double precision" 
       OFF)
option(ENABLE_SPNAV "whether 3DConnexion devices should be supported"
      OFF)
option(STATIC_PROPERTY_WORKAROUND "workaround for static property bug with some boost/boost_python combinations" OFF)
option(COMPILE_TESTS "whether unit tests should be compiled by default" OFF)
option(ENABLE_STATIC "whether static libraries should be compiled" OFF)
option(UBUNTU_LAYOUT "whether Debian/Ubuntu's lib and libexec directory layout should be used" OFF)
option(HIDDEN_VISIBILITY "on gcc, use -fvisibility=hidden" OFF)
option(ENABLE_MM "whether openmm support is added" OFF)

if (CXX)
  set(CMAKE_CXX_COMPILER ${CXX})
endif()

if (CC)
  set(CMAKE_C_COMPILER ${CC})
endif()

if (FORTRAN_COMPILER)
  set(CMAKE_FORTRAN_COMPILER ${FORTRAN_COMPILER})
endif()



if (PREFIX)
  set(CMAKE_INSTALL_PREFIX ${PREFIX})
endif()

if (SYS_ROOT)
  set(CMAKE_PREFIX_PATH ${SYS_ROOT})
endif()

if (OPTIMIZE)
  set(CMAKE_BUILD_TYPE Release)
  set(_OPT ON)
else()
   set(CMAKE_BUILD_TYPE Debug)
    set(_OPT OFF)
endif()

if (USE_DOUBLE_PRECISION)
  set(_DOUBLE_PREC ON)
else()
  set(_DOUBLE_PREC OFF)
  set(_DOUBLE_PREC OFF)
endif()

if (NOT ENABLE_INFO)
  set(ENABLE_GFX OFF)
endif()

if (NOT ENABLE_GFX)
  set(ENABLE_GUI OFF)
endif()

if (ENABLE_INFO)
  set(_INFO ON)
else()
  set(_INFO OFF)
endif()

if (ENABLE_GUI)
  set(_UI ON)
else()
  set(_UI OFF)
endif()

if (ENABLE_GFX)
  set(_OPENGL ON)
else()
  set(_OPENGL OFF)
endif()

if (USE_SHADER)
  set(_SHADER ON)
else()
  set(_SHADER OFF)
endif()
if (USE_NUMPY)
  set(_NUMPY ON)
else()
  set(_NUMPY OFF)
endif()
if (COMPILE_TMTOOLS)
  set(_TM_TOOLS ON)
else()
  set(_TM_TOOLS OFF)
endif()
if (ENABLE_IMG)
  set(_IMG ON)
else()
  set(_IMG OFF)
endif()
if (PROFILE)
  set(_PROFILE ON)
else()
  set(_PROFILE OFF)
endif()
if(ENABLE_MM)
  set(_OPENMM ON)
else()
  set(_OPENMM OFF)
endif()


if (UBUNTU_LAYOUT)
  set(_UBUNTU_LAYOUT ON)
else()
  set(_UBUNTU_LAYOUT OFF)
endif()

if (COMPOUND_LIB)
  set(_COMP_LIB "${COMPOUND_LIB}")
  if (NOT IS_ABSOLUTE "${COMPOUND_LIB}")
    set(COMPOUND_LIB "${CMAKE_CURRENT_BINARY_DIR}/${COMPOUND_LIB}")
  endif()
else()
  set(_COMP_LIB "NONE")
endif()

if (STATIC_PROPERTY_WORKAROUND)
  set(_STATICPROPS ON)
else()
  set(_STATICPROPS OFF)
endif()

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif()

setup_stage()
file(MAKE_DIRECTORY ${STAGE_DIR}
     ${EXECUTABLE_OUTPUT_PATH}
     ${HEADER_STAGE_PATH}
     ${LIB_STAGE_PATH}
     ${LIBEXEC_STAGE_PATH})

setup_compiler_flags()

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY)

if (ENABLE_STATIC AND UNIX AND NOT APPLE)
  set (CMAKE_FIND_LIBRARY_SUFFIXES .a)
endif()

# Python needed before Boost
find_package(Python 3.6 REQUIRED COMPONENTS Interpreter Development)
# where Python modules live
set(PYTHON_MODULE_PATH "python${Python_VERSION_MAJOR}.${Python_VERSION_MINOR}/site-packages/")

if(BOOST_VERSION)
  message(STATUS "forcing boost to version ${BOOST_VERSION}")
  set(_BOOST_MIN_VERSION ${BOOST_VERSION})
endif()
setup_boost()
if (WIN32)
   ADD_DEFINITIONS("-DBOOST_ALL_NO_LIB")
endif()

if (ENABLE_INFO)        
  find_package(Qt5Xml REQUIRED)
  set(QT_LIBRARIES ${QT_LIBRARIES} Qt5::Xml)
endif()

if (OPTIMIZE)
  if (CXX_FLAGS)
    set (CMAKE_CXX_FLAGS_RELEASE ${CXX_FLAGS})
  endif()
  if (C_FLAGS)
    set (CMAKE_C_FLAGS_RELEASE ${C_FLAGS})
  endif()
else()
  if (CXX_FLAGS)
    set(CMAKE_CXX_FLAGS_DEBUG ${CXX_FLAGS})
  endif()
  if (C_FLAGS)
    set(CMAKE_C_FLAGS_DEBUG ${C_FLAGS})
  endif()
endif()
if (ENABLE_GFX)
  if (OPENGLPREFERENCE_LEGACY)
    set(OpenGL_GL_PREFERENCE LEGACY)
  else()
    set(OpenGL_GL_PREFERENCE GLVND)
  endif(OPENGLPREFERENCE_LEGACY)
  find_package(OpenGL REQUIRED)
endif()

if (ENABLE_IMG OR ENABLE_GFX)
  find_package(PNG REQUIRED)
else()
  set (PNG_LIBRARY "")
endif()

find_package(EIGEN 3.2.0 REQUIRED)
find_package(SQLITE3 3.7.13 REQUIRED)

if(USE_NUMPY)
  find_package(Numpy REQUIRED)
endif()

if(ENABLE_MM)
  find_package(OpenMM REQUIRED)
  set(_OPENMM_PLUGINS "${OPEN_MM_PLUGIN_DIR}")
else(ENABLE_MM)
  set(_OPENMM_PLUGINS "NONE")
endif(ENABLE_MM)

if (ENABLE_IMG)
  find_package(FFTW REQUIRED)
  find_package(TIFF REQUIRED)
endif()


if (ENABLE_STATIC)
  set(Boost_LIBRARIES)
  set(Boost_USE_STATIC_LIBS ON)
  find_package(Boost ${_BOOST_MIN_VERSION} 
               COMPONENTS filesystem system iostreams regex thread REQUIRED)
  find_package(ZLIB REQUIRED)
   
  if (UNIX AND NOT APPLE)
    set(STATIC_LIBRARIES ${Boost_LIBRARIES} ${FFTW_LIBRARIES} ${TIFF_LIBRARIES} 
        ${PNG_LIBRARY} ${ZLIB_LIBRARY})
  else ()
    set(STATIC_LIBRARIES ${Boost_LIBRARIES} ${FFTW_LIBRARIES} ${TIFF_LIBRARIES} 
        ${PNG_LIBRARY} ${ZLIB_LIBRARY})
  endif()
endif()

if (ENABLE_GUI)
  find_package(Qt5Widgets REQUIRED)
  find_package(Qt5OpenGL REQUIRED)
  set(QT_LIBRARIES ${QT_LIBRARIES} Qt5::Gui Qt5::Widgets Qt5::Core)
  ost_find_python_module(PyQt5)
  ost_find_python_module_alt("PyQt5.sip;sip")
endif()

if (ENABLE_SPNAV)
  #find_package(SpNav REQUIRED)
  set(_SPNAV ON)
else()
  set(_SPNAV OFF)
endif()

if (CMAKE_COMPILER_IS_GNUCXX)
  # do not write back into cache, otherwise the compile command line gets expanded
  # with multiple -fno-strict-aliasing flags, triggering a complete rebuild whenever
  # cmake is run
  set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fno-strict-aliasing")
  if("${CMAKE_CXX_COMPILER_VERSION}" VERSION_GREATER "4.6")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-attributes")
  endif("${CMAKE_CXX_COMPILER_VERSION}" VERSION_GREATER "4.6")
  if(HIDDEN_VISIBILITY) 
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
    set (_HIDDEN_VIS ON)
  else(HIDDEN_VISIBILITY)
    set (_HIDDEN_VIS OFF)
  endif(HIDDEN_VISIBILITY)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unknown-warning-option")
endif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
if(CMAKE_C_COMPILER_ID MATCHES "Clang")
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unknown-warning-option")
endif(CMAKE_C_COMPILER_ID MATCHES "Clang")

# basic environment
include_directories(${Boost_INCLUDE_DIRS} 
                    ${FFTW_INCLUDE_DIRS} 
                    ${EIGEN3_INCLUDE_DIRS}
                    ${TIFF_INCLUDE_DIR}
                    ${PNG_INCLUDE_DIRS}
                    ${OPEN_MM_INCLUDE_DIRS}
                    ${SQLITE3_INCLUDE_DIRS}
                    )
if(USE_NUMPY)
include_directories(${PYTHON_NUMPY_INCLUDE_DIR})
endif()

if (UNIX)
  SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
  SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  if(USE_RPATH)
    set(_USE_RPATH ON)
    SET(CMAKE_INSTALL_RPATH "$ORIGIN/../${LIB_DIR}")
    SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  else()
    set(_USE_RPATH OFF)
   SET(CMAKE_INSTALL_RPATH "")
   SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)
  endif() 
endif()

if (ENABLE_STATIC)
  SET(CMAKE_SKIP_BUILD_RPATH TRUE)
  SET(LINK_SEARCH_END_STATIC TRUE) 
endif()

add_subdirectory(modules)
add_subdirectory(scripts)
add_subdirectory(tools)
add_subdirectory(actions)
# deployment has to come last, to ensure that all install commands are run before deployment
# magic is done
add_subdirectory(deployment)

set(FILES_TO_BE_REMOVED ${PROJECT_BINARY_DIR}/stage tests)
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
                             "${FILES_TO_BE_REMOVED}")


#ost_match_boost_python_version(${Python_LIBRARIES})

if (CMAKE_COMPILER_IS_GNUCXX)
   set(HIDDEN_VIS_MSG 
       "\n   Hidden object visibility  (-DHIDDEN_VISIBILITY) : ${_HIDDEN_VIS}")
endif()
message(STATUS 
        "OpenStructure will be built with the following options:\n"
        "   Install Prefix                        (-DPREFIX) : ${CMAKE_INSTALL_PREFIX}\n"
        "   RPath in install                   (-DUSE_RPATH) : ${_USE_RPATH}\n"
        "   Info support                     (-DENABLE_INFO) : ${_INFO}\n"
        "   Graphical interface               (-DENABLE_GUI) : ${_UI}\n"
        "   OpenGL support                    (-DENABLE_GFX) : ${_OPENGL}\n"
        "   Image Processing support          (-DENABLE_IMG) : ${_IMG}\n"
        "   Shader support                    (-DUSE_SHADER) : ${_SHADER}\n"
        "   Numpy support                      (-DUSE_NUMPY) : ${_NUMPY}\n"
        "   SpaceNav Device support         (-DENABLE_SPNAV) : ${_SPNAV}\n"
        "   OpenMM support                     (-DENABLE_MM) : ${_OPENMM}\n"
        "   OpenMM plugins            (-DOPEN_MM_PLUGIN_DIR) : ${_OPENMM_PLUGINS}\n"
        "   Optimize                            (-DOPTIMIZE) : ${_OPT}\n"
        "   Profiling support                    (-DPROFILE) : ${_PROFILE}\n"
        "   Double Precision        (-DUSE_DOUBLE_PRECISION) : ${_DOUBLE_PREC}\n"
        "   Compound Lib                    (-DCOMPOUND_LIB) : ${_COMP_LIB}\n"
        "   TMAlign and TMScore          (-DCOMPILE_TMTOOLS) : ${_TM_TOOLS}\n"
        "   Static Libraries               (-DENABLE_STATIC) : ${ENABLE_STATIC}\n"
        "   Debian/Ubuntu directory layout (-DUBUNTU_LAYOUT) : ${_UBUNTU_LAYOUT}"
        ${HIDDEN_VIS_MSG})


# LocalWords:  CMake CMP

=== modules/config/CMakeLists.txt ===
set(SUBST_DICT OST_VERSION_MAJOR=${OST_VERSION_MAJOR} OST_VERSION_MINOR=${OST_VERSION_MINOR} 
    OST_VERSION_PATCH=${OST_VERSION_PATCH})

set(OST_CONFIG_HEADERS
base.hh
config.hh
dllexport.hh
version.hh
)

set(animations_enabled 0)

if (USE_SHADER)
  set(shader_support 1)
else()
  set(shader_support 0)
endif()

if (USE_NUMPY)
  set(numpy_support 1)
else()
  set(numpy_support 0)
endif()
if (PROFILE)
  set(profiling_enabled 1)
else()
  set(profiling_enabled 0)
endif()
if (ENABLE_IMG)
  set(img_enabled 1)
else()
  set(img_enabled 0)
endif()
if (_DOUBLE_PREC)
  set(double_prec 1)
else()
  set(double_prec 0)
endif()
if (_DOUBLE_PREC)
  set(double_prec 1)
else()
  set(double_prec 0)
endif()
if (_STATICPROPS)
  set(static_props 1)
else()
  set(static_props 0)
endif()
if (FFTW_USE_THREADS)
  set(fftw_use_threads 1)
else()
  set(fftw_use_threads 0)
endif()
if (_UBUNTU_LAYOUT)
  set(ubuntu_layout 1)
else()
  set(ubuntu_layout 0)
endif()
if (ENABLE_INFO)
  set(info_enabled 1)
else()
  set(info_enabled 0)
endif()

set(config_hh_generator "CMake")
set(CONFIG_HH_FILE "${CMAKE_CURRENT_SOURCE_DIR}/config.hh")
set(VERSION_HH_FILE "${CMAKE_CURRENT_SOURCE_DIR}/version.hh")
configure_file(config.hh.in ${CONFIG_HH_FILE})
configure_file(version.hh.in ${VERSION_HH_FILE})
add_custom_target(ost_config)
stage_and_install_headers("${OST_CONFIG_HEADERS}" "ost" "ost_config")

=== modules/img/CMakeLists.txt ===
if (ENABLE_IMG)
  add_subdirectory(base)
  add_subdirectory(alg)
  if (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/ex)
    add_subdirectory(ex)
  endif()
endif()

=== modules/base/pymod/CMakeLists.txt ===
set(OST_BASE_PYMOD_SOURCES
  wrap_base.cc
  export_logger.cc
  export_range.cc
  export_units.cc
)
if (NOT ENABLE_STATIC)
  pymod(NAME base OUTPUT_DIR ost 
        CPP ${OST_BASE_PYMOD_SOURCES} 
        PY settings.py stutil.py table.py table_selector.py xmlrunner.py testutils.py)
endif() 

if(WIN32)
  set(SQ "'")
else(WIN32)
  set(SQ "\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\'")
endif(WIN32)
set(SUBST_DICT "ALL_ADDITIONAL_MODULES=")
if(ENABLE_GUI)
  set(SUBST_DICT "${SUBST_DICT},${SQ}gui${SQ}")
endif(ENABLE_GUI)
if(ENABLE_GFX)
  set(SUBST_DICT "${SUBST_DICT},${SQ}gfx${SQ}")
endif(ENABLE_GFX)
if(ENABLE_IMG)
  set(SUBST_DICT "${SUBST_DICT},${SQ}img${SQ}")
endif(ENABLE_IMG)
if(ENABLE_INFO)
  set(SUBST_DICT ${SUBST_DICT},${SQ}info${SQ})
endif(ENABLE_INFO)

if(NOT ENABLE_STATIC)
  script(NAME __init__.py
         INPUT __init__.py.in
         SUBSTITUTE "${SUBST_DICT}"
         TARGET ost_base_pymod
         OUTPUT_DIR "${LIB_DIR}/${PYTHON_MODULE_PATH}/ost")
endif()

=== modules/base/src/CMakeLists.txt ===
set(OST_BASE_SOURCES 
generic_property.cc
log.cc
log_sink.cc
profile.cc
units.cc
string_ref.cc
platform.cc
message.cc
test_utils/compare_files.cc
boost_filesystem_helper.cc
)

set(OST_BASE_HEADERS
generic_property.hh
integrity_error.hh
invalid_handle.hh
ptr_observer.hh
log.hh
log_sink.hh
profile.hh
dyn_cast.hh
stdint.hh
stdint_msc.hh
range.hh
module_config.hh
units.hh
message.hh
platform.hh
string_ref.hh
pod_vector.hh
fixed_string.hh
tri_matrix.hh
boost_filesystem_helper.hh
)

set(OST_EXPORT_HELPERS
generic_property_def.hh 
pair_to_tuple_conv.hh 
vec_to_list_conv.hh
)
module(NAME base SOURCES ${OST_BASE_SOURCES} 
       HEADERS ${OST_EXPORT_HELPERS} IN_DIR export_helper 
       compare_files.hh IN_DIR test_utils ${OST_BASE_HEADERS}
       DEPENDS_ON ost_geom
       HEADER_OUTPUT_DIR ost)

=== modules/bindings/pymod/CMakeLists.txt ===
set(OST_BINDINGS
__init__.py
lga.py
hbplus.py
msms.py
tmtools.py 
dssp.py
clustalw.py
utils.py
naccess.py
hhblits.py
hhblits2.py
hhblits3.py
blast.py
cadscore.py
kclust.py
ialign.py
)

set(OST_BINDINGS_PYMOD_SOURCES
  export_tmalign.cc
  wrap_bindings.cc
)

pymod(NAME bindings OUTPUT_DIR ost/bindings CPP ${OST_BINDINGS_PYMOD_SOURCES} 
      PY ${OST_BINDINGS})

=== modules/db/src/CMakeLists.txt ===
set(OST_DB_HEADERS
sqlite_wrap.hh
sqlite_conv.hh
module_config.hh
linear_indexer.hh
paged_array.hh
binary_container.hh
extract_data_helper.hh
)

set(OST_DB_SOURCES
sqlite_wrap.cc
linear_indexer.cc
binary_container.cc
extract_data_helper.cc
)

module(NAME db SOURCES ${OST_DB_SOURCES} HEADERS ${OST_DB_HEADERS} 
       DEPENDS_ON ost_base ost_geom ost_seq LINK ${SQLITE3_LIBRARIES})
if(WIN32)
  set_target_properties(ost_db PROPERTIES LINK_FLAGS "/DEF:${CMAKE_CURRENT_SOURCE_DIR}/sqlite3.def")
  add_definitions(/DSQLITE_ENABLE_COLUMN_METADATA)
else(WIN32)
  add_definitions(-DSQLITE_OMIT_LOAD_EXTENSION)
endif(WIN32)
if (ENABLE_STATIC AND UNIX AND NOT APPLE)
  target_link_libraries(ost_db ${CMAKE_DL_LIBS})
endif()

=== modules/gfx/pymod/CMakeLists.txt ===
set(OST_GFX_PYMOD_SOURCES
  wrap_gfx.cc
  export_scene.cc
  export_gfx_node.cc
  export_symmetry_node.cc
  export_gfx_obj.cc
  export_entity.cc
  export_surface.cc
  export_primitives.cc
  export_primlist.cc
  export_scene_observer.cc
  export_render_options.cc
  export_color.cc
  export_gradient.cc
  export_color_ops.cc
  export_glwin_base.cc
  export_exporter.cc
  export_bitmap.cc
)

if (ENABLE_IMG)
  set(OST_GFX_PYMOD_SOURCES ${OST_GFX_PYMOD_SOURCES} export_map.cc)
endif()

pymod(NAME gfx CPP ${OST_GFX_PYMOD_SOURCES} PY __init__.py py_gfx_obj.py)

set(GRADIENT_FILE
  gradients.xml
)
copy_if_different("${CMAKE_CURRENT_SOURCE_DIR}" "${STAGE_DIR}/share/openstructure/scene" 
                  "${GRADIENT_FILE}" "PRESET GRADIENTS" _ost_gfx)
                  
install(FILES ${GRADIENT_FILE} DESTINATION "share/openstructure/scene")

=== modules/gfx/src/CMakeLists.txt ===
set(OST_GFX_HEADERS
render_pass.hh
bitmap_io.hh
collada_exporter.hh
color.hh
entity.hh
entity_fw.hh
gl_helper.hh
gfx.hh
gfx_fw.hh
gfx_node.hh
gfx_node_fw.hh
gfx_node_visitor.hh
gfx_object_base.hh
gfx_object.hh
gfx_object_fw.hh
gfx_prim.hh
symmetry_node.hh
gfx_test_object.hh
glwin_base.hh
input.hh
prim_list.hh
scene.hh
selection.hh
surface.hh
texture.hh
vertex_array.hh
vertex_array_helper.hh
scene_observer.hh
gl_include.hh
glext_include.hh
render_mode.hh
material.hh
gradient.hh
gradient_manager.hh
module_config.hh
primitives.hh
povray_fw.hh
povray.hh
exporter.hh
exporter_fw.hh
gost_exporter.hh
)

set(OST_GFX_COLOR_OPS_HEADERS
color_op.hh
by_element_color_op.hh
by_chain_color_op.hh
uniform_color_op.hh
gradient_color_op.hh
entity_view_color_op.hh
basic_gradient_color_op.hh
gradient_level_color_op.hh
)

set(OST_GFX_RENDER_OPTIONS_HEADERS
render_options.hh
line_render_options.hh
custom_render_options.hh
cpk_render_options.hh
simple_render_options.hh
sline_render_options.hh
line_trace_render_options.hh
cartoon_render_options.hh
trace_render_options.hh
)


set(OST_GFX_IMPL_HEADERS
cartoon_renderer.hh
custom_renderer.hh
cpk_renderer.hh
debug_renderer.hh
simple_renderer.hh
sline_renderer.hh
trace_renderer.hh
line_trace_renderer.hh
backbone_trace.hh
entity_detail.hh
entity_renderer.hh
trace_renderer_base.hh
connect_renderer_base.hh
mapped_property.hh
entity_renderer_fw.hh
tabulated_trig.hh
fast_spheres.hh
)


if (ENABLE_IMG)
  list(APPEND OST_GFX_HEADERS color_ops/map_handle_color_op.hh)
endif()

set(OST_GFX_SOURCES
bitmap_io.cc
exporter.cc
collada_exporter.cc
color.cc
primitives.cc
entity.cc
symmetry_node.cc
gfx_node.cc
gfx_object.cc
gfx_prim.cc
gfx_test_object.cc
input.cc
prim_list.cc
scene.cc
selection.cc
surface.cc
gradient.cc
gradient_manager.cc
vertex_array.cc
vertex_array_helper.cc
material.cc
povray.cc
gost_exporter.cc
texture.cc
color_ops/color_op.cc
color_ops/by_element_color_op.cc
color_ops/by_chain_color_op.cc
color_ops/uniform_color_op.cc
color_ops/gradient_color_op.cc
color_ops/entity_view_color_op.cc
color_ops/basic_gradient_color_op.cc
color_ops/gradient_level_color_op.cc
impl/entity_renderer.cc
impl/entity_detail.cc
impl/cartoon_renderer.cc
impl/custom_renderer.cc
impl/cpk_renderer.cc
impl/debug_renderer.cc
impl/simple_renderer.cc
impl/sline_renderer.cc
impl/line_trace_renderer.cc
impl/backbone_trace.cc
impl/connect_renderer_base.cc
impl/trace_renderer_base.cc
impl/mapped_property.cc
impl/tabulated_trig.cc
impl/trace_renderer.cc
impl/fast_spheres.cc
render_options/render_options.cc
render_options/line_render_options.cc
render_options/custom_render_options.cc
render_options/cpk_render_options.cc
render_options/simple_render_options.cc
render_options/sline_render_options.cc
render_options/line_trace_render_options.cc
render_options/cartoon_render_options.cc
render_options/trace_render_options.cc
)

if (ENABLE_IMG)
  set(OST_GFX_MAP_IMPL_HEADERS
  map_iso_gen.hh
  map_iso_gen_s.hh
  map_iso_gen_s.hh
  map_iso_spec.hh
  map_octree.hh
  octree_isocont.hh
  )
  set(OST_GFX_MAP_SOURCES
  map_iso.cc
  map_slab.cc
  impl/map_iso_gen.cc
  impl/map_iso_gen_s.cc
  impl/map_iso_gen_o.cc
  impl/map_octree.cc
  impl/octree_isocont.cc
  )
  set(OST_GFX_MAP_HEADERS
  map_iso.hh
  map_slab.hh
  map_iso_prop.hh
  )  
  list(APPEND OST_GFX_COLOR_OPS_HEADERS map_handle_color_op.hh)
  list(APPEND OST_GFX_SOURCES color_ops/map_handle_color_op.cc)
else()
  set(OST_GFX_MAP_HEADERS "")
  set(OST_GFX_MAP_SOURCES "")  
endif()

if (USE_SHADER)
  list(APPEND OST_GFX_SOURCES shader.cc)
  list(APPEND OST_GFX_HEADERS shader.hh)
  list(APPEND OST_GFX_SOURCES impl/scene_fx.cc)
  list(APPEND OST_GFX_IMPL_HEADERS scene_fx.hh)
  if (NOT APPLE)
    set(OST_GLEW_HEADERS
       glew.h
       glxew.h
       wglew.h IN_DIR GL
    )
    list(APPEND OST_GFX_SOURCES GL/glew.c)
    include_directories("${STAGE_DIR}/include/ost/gfx")
  endif()  
endif()

set(OST_GFX_DEPENDENCIES "ost_conop;ost_seq")
if (ENABLE_IMG)
  set(OST_GFX_DEPENDENCIES "${OST_GFX_DEPENDENCIES};ost_img;ost_img_alg")
endif()

module(NAME gfx SOURCES ${OST_GFX_SOURCES} ${OST_GFX_MAP_SOURCES} 
       HEADERS ${OST_GFX_MAP_IMPL_HEADERS} ${OST_GFX_IMPL_HEADERS} IN_DIR impl
               ${OST_GFX_RENDER_OPTIONS_HEADERS} IN_DIR render_options
               ${OST_GFX_COLOR_OPS_HEADERS} IN_DIR color_ops
               ${OST_GLEW_HEADERS}
               ${OST_GFX_HEADERS} ${OST_GFX_MAP_HEADERS}
       DEPENDS_ON ${OST_GFX_DEPENDENCIES})

include_directories(${PNG_INCLUDE_DIRS} ${OPENGL_INCLUDE_DIR})

# link against OpenGL and PNG libraries
target_link_libraries(ost_gfx ${OPENGL_LIBRARIES} ${PNG_LIBRARIES})

if (USE_SHADER)
  set(SHADER_FILES
    shader/aaline_fs.glsl
    shader/amboccl_fs.glsl
    shader/basic_fs.glsl
    shader/basic_vs.glsl
    shader/beacon_fs.glsl
    shader/convolute1_fs.glsl
    shader/dumpnorm_fs.glsl
    shader/dumpnorm_vs.glsl
    shader/fast_sphere_fs.glsl
    shader/fraglight_fs.glsl
    shader/fraglight_vs.glsl
    shader/iso_fs.glsl
    shader/iso_vs.glsl
    shader/noop_vs.glsl
    shader/outline_vs.glsl
    shader/quadpp_vs.glsl
    shader/scenefx_fs.glsl
    shader/scenefx_vs.glsl
    shader/selfx_fs.glsl
    shader/selfx_vs.glsl
    shader/screenblur4_fs.glsl
    shader/test_tex_fs.glsl
    shader/material_phong.glsl
    shader/material_hemi.glsl
    shader/material_toon1.glsl
    shader/material_toon2.glsl
    shader/anaglyph_fs.glsl
  )
  copy_if_different("${CMAKE_CURRENT_SOURCE_DIR}" "${SHARED_DATA_PATH}/shader" "${SHADER_FILES}" 
                    "SHADER_TARGETS" ost_gfx)  
  install(FILES ${SHADER_FILES} DESTINATION "share/openstructure/shader")
endif(USE_SHADER)
set(TEXTURE_FILES
  test_texture.png
  glyph_texture.png
)
copy_if_different("${CMAKE_CURRENT_SOURCE_DIR}" "${SHARED_DATA_PATH}/textures" "${TEXTURE_FILES}" 
                  "TEXTURE_TARGETS" ost_gfx)  

install(FILES ${TEXTURE_FILES} DESTINATION "share/openstructure/textures")

=== modules/gfx/tests/CMakeLists.txt ===
set(OST_GFX_UNIT_TESTS
  tests.cc
  test_gfx_node.cc
  test_color.cc
  test_gfx.py
)
if (ENABLE_IMG)
  list(APPEND OST_GFX_UNIT_TESTS test_map_octree.cc)
endif()

ost_unittest(MODULE gfx
             SOURCES "${OST_GFX_UNIT_TESTS}"
             LINK ost_io)

=== modules/gui/pymod/CMakeLists.txt ===
set(OST_GUI_PYMOD_SOURCES
  wrap_gui.cc
  export_alignment_view.cc
  export_message_widget.cc  
  export_gl_win.cc
  export_tool.cc
  export_py_shell.cc
  export_gosty.cc
  export_scene_win.cc
  export_sequence_viewer.cc
  export_perspective.cc
  export_sip_handler.cc
  export_scene_selection.cc
  export_main_area.cc
  export_panels.cc
  export_menu_bar.cc
  export_file_loader.cc
  export_file_viewer.cc
  export_widget.cc
  export_gl_canvas.cc
)
set(OST_GUI_SCENE_PYMOD_MODULES
__init__.py
color_options_widget.py
color_select_widget.py
combo_options_widget.py
cpk_widget.py
custom_widget.py
gradient_editor_widget.py
gradient_info_handler.py
gradient_list_model.py
gradient_preset_widget.py
hsc_widget.py
immutable_gradient_info_handler.py
immutable_preset_info_handler.py
init_inspector.py
inspector_widget.py
map_level_widget.py
preset.py
remote.py
preset_editor_list_model.py
preset_editor_widget.py
preset_info_handler.py
preset_list_model.py
preset_widget.py
render_mode_widget.py
render_op.py
render_options_widget.py
scene_observer_impl.py
scene_selection_helper.py
simple_widget.py
sline_widget.py
toolbar_options_widget.py
trace_widget.py
tube_widget.py
uniform_color_widget.py
visibility_op.py
line_trace_widget.py
wireframe_widget.py
query_editor.py
)
if (ENABLE_IMG)
  list(APPEND OST_GUI_PYMOD_SOURCES
  data_viewer_proxy.cc
  export_data_viewer.cc
  export_overlay.cc
  export_overlay_manager.cc
  )
endif()

if (ENABLE_SPNAV)
  list( APPEND OST_GUI_PYMOD_SOURCES
  export_input.cc
  )
endif()

set(OST_GUI_PYMOD_MODULES
  __init__.py
  init_context_menu.py
  init_menubar.py
  init_spacenav.py
  init_splash.py
  trajectory_viewer.py
  helpwidget.py
  table.py
  gosty_startup.py
)

set(OST_GUI_PYMOD_DNG_MODULES
  __init__.py
  termuse.py
  superpositiondialog.py
  init.py
  menu.py
)

pymod(NAME gui CPP ${OST_GUI_PYMOD_SOURCES} 
      PY ${OST_GUI_SCENE_PYMOD_MODULES} IN_DIR scene
         ${OST_GUI_PYMOD_DNG_MODULES} IN_DIR dng
         ${OST_GUI_PYMOD_MODULES})

set(PRESET_FILES
  scene/presets.xml
)
copy_if_different("${CMAKE_CURRENT_SOURCE_DIR}" "${STAGE_DIR}/share/openstructure/scene" 
                  "${PRESET_FILES}" "IMMUTABLE_FILES" _ost_gui)
install(FILES ${PRESET_FILES} DESTINATION "share/openstructure/scene")

set(INSPECTOR_ICONS
  scene/icons/color_icon.png
  scene/icons/preset_icon.png  
  scene/icons/render_icon.png
  scene/icons/tool_icon.png
)
copy_if_different("${CMAKE_CURRENT_SOURCE_DIR}" "${STAGE_DIR}/share/openstructure/scene/icons" 
                  "${INSPECTOR_ICONS}" "ICONS_FOR_INSPECTOR" _ost_gui)
install(FILES ${INSPECTOR_ICONS} DESTINATION "share/openstructure/scene/icons")

set(QT_USE_QTOPENGL 1)
set(QT_USE_QTNETWORK 1)

target_link_libraries(_ost_gui ${QT_LIBRARIES})

=== modules/gui/src/CMakeLists.txt ===
set(OST_GUI_PANEL_BAR_HEADERS
button_bar.hh
drop_box.hh
panel_bar.hh
panel_manager.hh
bottom_bar.hh
button_box.hh
event_button.hh
panel_widget_container.hh
panel_bar_widget_holder.hh
side_bar.hh
splitter_panel_bar.hh
tabbed_panel_bar.hh
)

set(OST_GUI_SEQUENCE_VIEWER_HEADERS
align_properties_painter.hh
base_row.hh
background_painter.hh
conservation_painter.hh
painter.hh
secstr_row.hh
seq_secstr_painter.hh
seq_selection_painter.hh
seq_text_painter.hh
sequence_delegate.hh
sequence_model.hh
sequence_row.hh
sequence_search_bar.hh
sequence_table_view.hh
sequence_viewer.hh
tick_painter.hh
title_row.hh
alignment_view_object.hh
base_view_object.hh
sequence_view_object.hh
)

set(OST_GUI_TOOLS_HEADERS
tool.hh
tool_option_group.hh
tool_options.hh
tool_bar.hh
selection_tool.hh
measure_tool.hh
tool_option.hh
tool_manager.hh
tool_options_widget.hh
manipulator.hh
tool_options_win.hh
mouse_event.hh
)
set(OST_GUI_PYTHON_SHELL_HEADERS
main_thread_runner.hh
output_redirector.hh
completer_base.hh
dir_model.hh
gutter.hh
path_completer.hh
python_context_parser.hh
python_completer.hh
python_shell.hh
python_shell_fw.hh
python_shell_widget.hh
python_tokenizer.hh
python_syntax_highlighter.hh
text_logger.hh
python_interpreter.hh
python_interpreter_worker.hh
python_shell_text_document_layout.hh
shell_history.hh
state_machine.hh
state.hh
transition.hh
transition_guard.hh
)

set(OST_GUI_SCENE_WIN_HEADERS
context_menu.hh
current_selection_node.hh
custom_part_node.hh
entity_node.hh
entity_part_node.hh
gfx_scene_node.hh
label_node.hh
root_node.hh
render_mode_node.hh
render_modes_node.hh
scene_node.hh
scene_win.hh
scene_win_model.hh
)

set(OST_GUI_MESSAGES_HEADERS
message_widget.hh
message_box_widget.hh
log_reader.hh
)

if (ENABLE_SPNAV)
include_directories(${SPNAV_INCLUDE_DIR})
set(OST_GUI_INPUT_HEADERS
spnav_input.hh
  IN_DIR input
)
endif()

set(OST_GUI_PLOT_VIEWER_HEADERS
plot_axis_base.hh
plot_axis_horizontal.hh
plot_axis_vertical.hh
plot_data.hh
plot_data_base.hh
plot_data_entry.hh
plot_data_graphics_item.hh
plot_data_graphics_item_base.hh
plot_data_info.hh
plot_data_info_fw.hh
plot_function.hh
plot_function_info.hh
plot_function_graphics_item.hh
plot_graphics_cross_item.hh
plot_graphics_diagonal_cross_item.hh
plot_graphics_ellipse_item.hh
plot_graphics_rectangle_item.hh
plot_group_graphics_item.hh
plot_group_info.hh
plot_group.hh
plot_info_base.hh
plot_legend_panel.hh
plot_ticker.hh
plot_ticker_fw.hh
plot_types.hh
)

if (ENABLE_IMG)
  set(OST_GUI_DATA_VIEWER_HEADERS
  argand.hh
  data_viewer.hh
  data_viewer_panel.hh
  data_viewer_panel_base.hh
  draw_overlay.hh
  drawing_functions.hh
  fft_panel.hh
  info_panel.hh
  img2qt.hh
  mask_overlay.hh
  null_overlay.hh
  overlay.hh
  overlay_base.hh
  overlay_base_fw.hh
  overlay_manager.hh
  overlay_manager_fw.hh
  overlay_manager_gui.hh
  overlay_manager_observer.hh
  pointlist_overlay.hh
  pointlist_overlay_base.hh
  strategies.hh
  strategies_fw.hh
  viewer_normalizer.hh
  IN_DIR data_viewer
  )
endif()

set(OST_GUI_HEADERS
file_browser.hh
file_type_dialog.hh
file_viewer.hh
gl_canvas.hh
gl_win.hh
scene_menu.hh
gosty_app.hh
admin.hh
module_config.hh
main.hh
main_area.hh
perspective.hh
scene_selection.hh
main_window.hh
dock_widget.hh
dock_widget.hh
thin_splitter.hh
widget.hh
widget_geom_handler.hh
widget_pool.hh
widget_registry.hh
widget_state_saver.hh
file_loader.hh
)

set(OST_GUI_SOURCES
thin_splitter.cc
perspective.cc
widget_registry.cc
file_browser.cc
file_type_dialog.cc
file_viewer.cc
main.cc
gl_canvas.cc
dock_widget.cc
main_window.cc
gl_win.cc
scene_menu.cc
widget.cc
admin.cc
widget_pool.cc
messages/message_widget.cc
messages/message_box_widget.cc
messages/log_reader.cc
sequence_viewer/align_properties_painter.cc
sequence_viewer/base_row.cc
sequence_viewer/background_painter.cc
sequence_viewer/conservation_painter.cc
sequence_viewer/secstr_row.cc
sequence_viewer/seq_secstr_painter.cc
sequence_viewer/seq_selection_painter.cc
sequence_viewer/seq_text_painter.cc
sequence_viewer/sequence_delegate.cc
sequence_viewer/sequence_model.cc
sequence_viewer/sequence_row.cc
sequence_viewer/sequence_search_bar.cc
sequence_viewer/sequence_table_view.cc
sequence_viewer/sequence_viewer.cc
sequence_viewer/tick_painter.cc
sequence_viewer/title_row.cc
sequence_viewer/alignment_view_object.cc
sequence_viewer/base_view_object.cc
sequence_viewer/sequence_view_object.cc
gosty_app.cc
main_area.cc
widget_state_saver.cc
scene_selection.cc
widget_geom_handler.cc
file_loader.cc
panels/button_bar.cc
panels/drop_box.cc
panels/panel_bar.cc
panels/bottom_bar.cc
panels/button_box.cc
panels/event_button.cc
panels/panel_manager.cc
panels/panel_widget_container.cc
panels/panel_bar_widget_holder.cc
panels/side_bar.cc
panels/splitter_panel_bar.cc
panels/tabbed_panel_bar.cc
tools/tool_option_group.cc
tools/tool_options.cc
tools/tool_option.cc
tools/tool_manager.cc
tools/tool_options_win.cc
tools/tool.cc
tools/mouse_event.cc
tools/manipulator.cc
tools/tool_options_widget.cc
tools/tool_bar.cc
tools/selection_tool.cc
tools/measure_tool.cc
python_shell/gutter.cc
python_shell/main_thread_runner.cc
python_shell/output_redirector.cc
python_shell/completer_base.cc
python_shell/dir_model.cc
python_shell/path_completer.cc
python_shell/python_context_parser.cc
python_shell/python_completer.cc
python_shell/python_interpreter.cc
python_shell/python_interpreter_worker.cc
python_shell/python_namespace_tree_model.cc
python_shell/python_namespace_tree_item.cc
python_shell/python_shell.cc
python_shell/python_shell_widget.cc
python_shell/python_shell_text_document_layout.cc
python_shell/python_tokenizer.cc
python_shell/python_syntax_highlighter.cc
python_shell/shell_history.cc
python_shell/string_literal_positions.cc
python_shell/text_logger.cc
python_shell/state_machine.cc
python_shell/state.cc
python_shell/transition.cc
python_shell/transition_guard.cc
scene_win/context_menu.cc
scene_win/current_selection_node.cc
scene_win/custom_part_node.cc
scene_win/scene_node.cc
scene_win/label_node.cc
scene_win/entity_node.cc
scene_win/entity_part_node.cc
scene_win/gfx_scene_node.cc
scene_win/render_mode_node.cc
scene_win/render_modes_node.cc
scene_win/root_node.cc
scene_win/scene_win.cc
scene_win/scene_win_model.cc
)

set(HEADERS_TO_BE_MOCCED
file_browser.hh
file_type_dialog.hh
file_viewer.hh
gl_canvas.hh
gl_win.hh
scene_menu.hh
gosty_app.hh
main.hh
main_area.hh
perspective.hh
dock_widget.hh
main_window.hh
scene_selection.hh
widget.hh
widget_geom_handler.hh
widget_pool.hh
messages/message_widget.hh
messages/message_box_widget.hh
messages/log_reader.hh
sequence_viewer/align_properties_painter.hh
sequence_viewer/background_painter.hh
sequence_viewer/base_row.hh
sequence_viewer/conservation_painter.hh
sequence_viewer/painter.hh
sequence_viewer/secstr_row.hh
sequence_viewer/seq_secstr_painter.hh
sequence_viewer/seq_selection_painter.hh
sequence_viewer/seq_text_painter.hh
sequence_viewer/sequence_delegate.hh
sequence_viewer/sequence_model.hh
sequence_viewer/sequence_row.hh
sequence_viewer/sequence_search_bar.hh
sequence_viewer/sequence_table_view.hh
sequence_viewer/sequence_viewer.hh
sequence_viewer/tick_painter.hh
sequence_viewer/title_row.hh
sequence_viewer/alignment_view_object.hh
sequence_viewer/base_view_object.hh
sequence_viewer/sequence_view_object.hh
python_shell/main_thread_runner.hh
python_shell/completer_base.hh
python_shell/gutter.hh
python_shell/output_redirector.hh
python_shell/path_completer.hh
python_shell/python_completer.hh
python_shell/python_interpreter.hh
python_shell/python_interpreter_worker.hh
python_shell/python_namespace_tree_model.hh
python_shell/python_shell.hh
python_shell/python_shell_widget.hh
python_shell/text_logger.hh
python_shell/state_machine.hh
python_shell/state.hh
python_shell/transition.hh
python_shell/transition_guard.hh
panels/button_bar.hh
panels/drop_box.hh
panels/panel_bar.hh
panels/panel_manager.hh
panels/bottom_bar.hh
panels/button_box.hh
panels/event_button.hh
panels/panel_widget_container.hh
panels/panel_bar_widget_holder.hh
panels/side_bar.hh
panels/splitter_panel_bar.hh
panels/tabbed_panel_bar.hh
scene_win/context_menu.hh
scene_win/current_selection_node.hh
scene_win/custom_part_node.hh
scene_win/gfx_scene_node.hh
scene_win/label_node.hh
scene_win/entity_node.hh
scene_win/entity_part_node.hh
scene_win/render_mode_node.hh
scene_win/render_modes_node.hh
scene_win/root_node.hh
scene_win/scene_node.hh
scene_win/scene_win.hh
scene_win/scene_win_model.hh
tools/tool.hh
tools/tool_option_group.hh
tools/tool_options.hh
tools/tool_bar.hh
tools/tool_option.hh
tools/tool_manager.hh
tools/tool_options_widget.hh
tools/measure_tool.hh
tools/tool_options_win.hh
)
if (ENABLE_IMG)
  list(APPEND OST_GUI_TOOLS_HEADERS map_tool.hh)
  list(APPEND OST_GUI_SOURCES
       tools/map_tool.cc
       data_viewer/argand.cc
       data_viewer/data_viewer.cc
       data_viewer/data_viewer_panel.cc
       data_viewer/data_viewer_panel_base.cc
       data_viewer/draw_overlay.cc
       data_viewer/drawing_functions.cc
       data_viewer/fft_panel.cc
       data_viewer/info_panel.cc
       data_viewer/img2qt.cc
       data_viewer/mask_overlay.cc
       data_viewer/null_overlay.cc
       data_viewer/overlay_base.cc
       data_viewer/overlay_manager.cc
       data_viewer/overlay_manager_gui.cc
       data_viewer/pointlist_overlay.cc
       data_viewer/pointlist_overlay_base.cc
       data_viewer/strategies.cc
       data_viewer/viewer_normalizer.cc)
  list(APPEND HEADERS_TO_BE_MOCCED
    data_viewer/argand.hh
    data_viewer/fft_panel.hh
    data_viewer/info_panel.hh
    data_viewer/data_viewer.hh
    data_viewer/overlay_manager_gui.hh
    data_viewer/data_viewer_panel_base.hh
    data_viewer/null_overlay.hh
    data_viewer/overlay_base.hh
    data_viewer/pointlist_overlay_base.hh
  )
endif()

if (ENABLE_SPNAV)
  set(spnav_enabled 1)
  list(APPEND OST_GUI_SOURCES
      input/spnav_input.cc
  )
  list(APPEND HEADERS_TO_BE_MOCCED
      input/spnav_input.hh
  )
else()
  set(spnav_enabled 0)
endif()

set(config_hh_generator "CMake")
set(MODULE_CONFIG_HH_FILE "${CMAKE_CURRENT_SOURCE_DIR}/module_config.hh")
configure_file(module_config.hh.in ${MODULE_CONFIG_HH_FILE})
# the resulting file, module_config.hh, is already included in OST_GUI_HEADERS

if (APPLE)
  set(ADDITIONAL_LIBRARIES "-framework Security")
endif()
set(QT_USE_QTOPENGL 1)
set(QT_USE_QTNETWORK 1)

qt5_wrap_cpp(OST_GUI_MOCS "${HEADERS_TO_BE_MOCCED}" 
             OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED
                     -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)
module(NAME gui SOURCES ${OST_GUI_MOCS} ${OST_GUI_SOURCES}
       HEADERS ${OST_GUI_TOOLS_HEADERS} IN_DIR tools
               ${OST_GUI_SEQUENCE_VIEWER_HEADERS} IN_DIR sequence_viewer
               ${OST_GUI_PYTHON_SHELL_HEADERS} IN_DIR python_shell
               ${OST_GUI_PANEL_BAR_HEADERS} IN_DIR panels
               ${OST_GUI_SCENE_WIN_HEADERS} IN_DIR scene_win
               ${OST_GUI_MESSAGES_HEADERS} IN_DIR messages
               ${OST_GUI_INPUT_HEADERS}
               ${OST_GUI_DATA_VIEWER_HEADERS}
               ${OST_GUI_HEADERS}
       DEPENDS_ON ost_gfx ost_io ost_mol_alg ost_seq_alg
       LINK ${QT_LIBRARIES}
            ${Python_LIBRARIES} 
            ${BOOST_PYTHON_LIBRARIES}
            ${SPNAV_LIBRARIES}
        NO_STATIC)


   
if (ADDITIONAL_LIBRARIES)
  target_link_libraries(ost_gui "${ADDITIONAL_LIBRARIES}")
endif()

include_directories(${Python_INCLUDE_DIRS})
qt5_add_resources(OST_QT_RESOURCE dngr.qrc)
qt5_wrap_cpp(OST_GOSTY_MOC "gosty.hh"
             OPTIONS -DBOOST_TT_HAS_OPERATOR_HPP_INCLUDED
                     -DBOOST_NO_TEMPLATE_PARTIAL_SPECIALIZATION)

set(LINK LINK ${QT_LIBRARIES} ${BOOST_PROGRAM_OPTIONS_LIBRARIES})

executable_libexec(NAME gosty SOURCES gosty.cc ${OST_GOSTY_MOC}
                   ${OST_QT_RESOURCE} DEPENDS_ON ost_gui ${LINK})
           
file(GLOB MOC_CXX_FILES moc_*.cxx)

if (MOC_CXX_FILES)
  set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
                           "${MOC_CXX_FILES}")
endif()

=== debian/changelog ===
openstructure (2.2.0-6) unstable; urgency=medium

  * Adding upstream-provided patch to fix tests on arm64.

 -- Andrius Merkys <merkys@debian.org>  Wed, 10 Feb 2021 04:33:33 -0500

openstructure (2.2.0-5) unstable; urgency=medium

  * Applying upstream patches to fix the compatibility with dssp >= 4.
  * Bringing back tests with dssp.

 -- Andrius Merkys <merkys@debian.org>  Wed, 06 Jan 2021 09:30:24 -0500

openstructure (2.2.0-4) unstable; urgency=medium

  * Adding upstream-provided patch to increase test tolerances in order to
    fix builds on arm64 and other architectures.

 -- Andrius Merkys <merkys@debian.org>  Tue, 05 Jan 2021 07:51:29 -0500

openstructure (2.2.0-3) unstable; urgency=medium

  * Skipping tests for dssp, as dssp >= 4 is incompatible with current
    openstructure code.

 -- Andrius Merkys <merkys@debian.org>  Mon, 21 Dec 2020 01:08:59 -0500

openstructure (2.2.0-2) unstable; urgency=medium

  * Installing files for libdevel packages.
  * Dropping test dependency on dssp for now due to test failures.

 -- Andrius Merkys <merkys@debian.org>  Wed, 09 Dec 2020 02:00:44 -0500

openstructure (2.2.0-1) unstable; urgency=medium

  * New upstream version 2.2.0
  * Refreshing patches.

 -- Andrius Merkys <merkys@debian.org>  Mon, 23 Nov 2020 01:35:58 -0500

openstructure (2.2.0~rc-1) unstable; urgency=medium

  * New upstream version 2.2.0~rc (Closes: #972771).
  * Refreshing and describing patches.
  * Bumping Standards-Version (no changes).
  * Bumping debhelper-compat (no changes).

 -- Andrius Merkys <merkys@debian.org>  Thu, 19 Nov 2020 06:37:26 -0500

openstructure (2.1.0-1) unstable; urgency=medium

  * New upstream version 2.1.0
  * Refreshing patches.
  * Accommodating soname change.

 -- Andrius Merkys <merkys@debian.org>  Fri, 18 Sep 2020 04:12:51 -0400

=== debian/control ===
Source: openstructure
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Build-Depends:
 clustalw <!nocheck>,
 cmake,
 debhelper-compat (= 13),
 dh-python,
 dssp <!nocheck>,
 libboost-all-dev,
 libeigen3-dev,
 libfftw3-dev,
 libglu1-mesa-dev,
 libpng-dev,
 libqt5opengl5-dev,
 libsqlite3-dev,
 libtiff-dev,
 python3-dev,
 python3-matplotlib <!nocheck>,
 python3-numpy <!nocheck>,
 python3-pil <!nocheck>,
 python3-pyqt5,
 python3-scipy <!nocheck>,
 qtbase5-dev,
 sip-dev,
 voronota <!nocheck>,
Standards-Version: 4.5.0
Homepage: https://www.openstructure.org
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debichem-team/openstructure.git
Vcs-Browser: https://salsa.debian.org/debichem-team/openstructure

Package: libost-base2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-bindings2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-conop2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-db2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-geom2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-gfx2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-gui2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-img-alg2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-img2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-info2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-io2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-mol-alg2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-mol2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-seq-alg2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-seq2.2
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: openstructure
Architecture: any
Depends:
 python3-ost,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: python3-ost
Architecture: any
Section: python
Depends:
 python3-matplotlib,
 python3-numpy,
 python3-pil,
 python3-pyqt5,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Open-Source Computational Structural Biology Framework - Python 3 package
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-base-dev
Section: libdevel
Architecture: any
Depends:
 libost-base2.2 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-bindings-dev
Section: libdevel
Architecture: any
Depends:
 libost-bindings2.2 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-conop-dev
Section: libdevel
Architecture: any
Depends:
 libost-conop2.2 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-db-dev
Section: libdevel
Architecture: any
Depends:
 libost-db2.2 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-geom-dev
Section: libdevel
Architecture: any
Depends:
 libost-geom2.2 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-gfx-dev
Section: libdevel
Architecture: any
Depends:
 libost-gfx2.2 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-gui-dev
Section: libdevel
Architecture: any
Depends:
 libost-gui2.2 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-img-alg-dev
Section: libdevel
Architecture: any
Depends:
 libost-img-alg2.2 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-img-dev
Section: libdevel
Architecture: any
Depends:
 libost-img2.2 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-info-dev
Section: libdevel
Architecture: any
Depends:
 libost-info2.2 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-io-dev
Section: libdevel
Architecture: any
Depends:
 libost-io2.2 (= ${binary:Version}),
 ${misc:Depends},
Description: Open-Source Computational Structural Biology Framework
 OpenStructure aims to provide an open-source, modular, flexible, molecular
 modelling and visualization environment. It is targeted at interested method
 developers in the field of structural bioinformatics.

Package: libost-mol-alg-dev
Section: libdevel
Architecture: any
Depends:
 libost-mol-alg2.2 (= ${binary:Version}),

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DUBUNTU_LAYOUT=ON

override_dh_auto_install:
	dh_auto_install
	find debian/tmp/usr/lib -name '*.pyc' | xargs --no-run-if-empty rm

override_dh_install:
	dh_install
	find debian/python3-ost/usr/lib/python3/dist-packages -type f \
		| xargs --no-run-if-empty chmod -x

=== debian/watch ===
version=4
opts=uversionmangle=s/-/~/g \
https://git.scicore.unibas.ch/schwede/openstructure/-/tags \
 (?:.*?/)?openstructure-(\d[\d.]*(?:-rc)?)\.tar\.gz
